
class IntTree {
    public class treenode {
	private int data_;
	private treenode left_, right_;
	public treenode(int d, treenode l, treenode r) {data_ = d; left_ = l; right_ = r;}
	public int data() {return data_;}
	public treenode left()  {return left_;}
	public treenode right() {return right_;}
	public void setdata(int v) {data_ = v;}
	public void setleft (treenode tl) {left_ = tl;}
	public void setright(treenode tr) {right_ = tr;}
    }

    private treenode root_ = null;

    public void intraverse() {intraverse2(root_, 0);}

    private void intraverse(treenode p, int depth) {
	if (p==null) return;
	intraverse(p.left(), depth+1);
	for (int i=0;i<depth; i++) System.out.print("   ");
	System.out.println(p.data());
	intraverse(p.right(), depth+1);
    }

    private void intraverse2(treenode p, int depth) {
	if (p==null) return;
	intraverse2(p.right(), depth+1);
	for (int i=0;i<depth; i++) System.out.print("   ");
	System.out.println(p.data());
	intraverse2(p.left(), depth+1);
    }

    public void pretraverse() {pretraverse(root_);}

    private void pretraverse(treenode p) {
	if (p==null) return;
	System.out.println(p.data());
	pretraverse(p.left());
	pretraverse(p.right());
    }

    public void posttraverse() {posttraverse(root_);}

    private void posttraverse(treenode p) {
	if (p==null) return;
	posttraverse(p.left());
	posttraverse(p.right());
	System.out.println(p.data());
    }
  
    // recursively find sum, etc

    public int sum() {return sum(root_);}

    private static int sum(treenode t) {	
	if (t==null) return 0;
	return sum(t.left()) + t.data() + sum(t.right());
    }

    public int max() {return max(root_);}

    private static int max(treenode t) {	
	if (t==null) return 0;
	return max3(max(t.left()), t.data(), max(t.right()));
    }

    private static int max(int x, int y) {
	if (x>y) return x;
	else return y;
    }

    private static int max3(int x, int y, int z) {
	if (x>=y && x>=z) return x;
	if (y>=z) return y;
	return z;
    }

    public int depth() {return depth(root_);}

    private static int depth(treenode t) {	
	if (t==null) return 0;
	return max(depth(t.left()), depth(t.right())) + 1;
    }

    public void insert(int val) {
	if (root_ == null) {
		root_ = new treenode(val, null, null);
		return;
	}
	insert(val, root_);
    }

    // recursive insert: does not get called with t==null
    private void insert(int val, treenode t) {
	if (val == t.data() ) return;	// should we do something else?
	if (val < t.data()) {
	    if (t.left() == null) {
		t.setleft(new treenode(val, null, null));
	    } else {
		insert(val, t.left());
	    }
	} else { // val > t.data()
	    if (t.right() == null) {
		t.setright(new treenode(val, null, null));
	    } else {
		insert(val, t.right());
	    }
	}
    }

    public boolean search(int val) {
	if (root_ == null) return false;
	else return search(val, root_);
    }

    private boolean search(int val, treenode t) {
        if (t==null) return false;	
	else if (val == t.data()) return true;
	else if (val < t.data()) return search(val, t.left());
	else /* (val > t.data()) */ return search(val, t.right());
    }


}